// ChildFrm.cpp : implementation of the CChildFrame class
//

#include "stdafx.h"
#include "TrlEd.h"
#include "trdefs.h"
#include "TextileViewer.h"
#include "ObjtexViewer.h"
#include "ChildFrm.h"
#include "MainFrm.h"
#include "TrlEdDoc.h"
#include "MainView.h"
#include "EditorView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CChildFrame

IMPLEMENT_DYNCREATE(CChildFrame, CMDIChildWnd)

BEGIN_MESSAGE_MAP(CChildFrame, CMDIChildWnd)
    //{{AFX_MSG_MAP(CChildFrame)
	ON_WM_SIZE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CChildFrame construction/destruction

CChildFrame::CChildFrame()
{
    m_bInitialized = FALSE;
}

CChildFrame::~CChildFrame()
{
}

BOOL CChildFrame::PreCreateWindow(CREATESTRUCT& cs)
{
    cs.style |= WS_CHILD|WS_OVERLAPPED|WS_CAPTION|WS_VISIBLE|WS_MAXIMIZEBOX|WS_MINIMIZEBOX|WS_MAXIMIZE;
    cs.style &= ~FWS_ADDTOTITLE;
    //cs.dwExStyle |= WS_EX_TOOLWINDOW;
    cs.lpszName = "room 0";
    return CMDIChildWnd::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CChildFrame diagnostics

#ifdef _DEBUG
void CChildFrame::AssertValid() const
{
    CMDIChildWnd::AssertValid();
}

void CChildFrame::Dump(CDumpContext& dc) const
{
    CMDIChildWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CChildFrame message handlers

BOOL CChildFrame::OnCreateClient(LPCREATESTRUCT lpcs, CCreateContext* pContext) 
{
    RECT rect;
    CTrlEdDoc *pDoc = (CTrlEdDoc *)pContext->m_pCurrentDoc;
    GetClientRect(&rect);
    pDoc->m_pChildFrame = this;
    m_Splitter.CreateStatic(this, 1, 2);
    m_Splitter.CreateView(0, 0, RUNTIME_CLASS(CMainView), CSize(rect.right/2, rect.bottom), pContext);
    pDoc->m_pMainView = (CView *)m_Splitter.GetPane(0, 0);
    m_Splitter2.CreateStatic(&m_Splitter, 2, 1, WS_CHILD|WS_VISIBLE|WS_BORDER, m_Splitter.IdFromRowCol(0, 1));
    m_Splitter2.CreateView(0, 0, pContext->m_pNewViewClass, CSize(rect.right-(rect.right/2), rect.bottom/2), pContext);
    pDoc->m_pSectorView = (CView *)m_Splitter2.GetPane(0, 0);
    m_Splitter2.CreateView(1, 0, RUNTIME_CLASS(CEditorView), CSize(rect.right-(rect.right/2), rect.bottom-(rect.bottom/2)), pContext);
    pDoc->m_pEditorView = (CView *)m_Splitter2.GetPane(0, 0);
    m_bInitialized = TRUE;
    return TRUE;
}

void CChildFrame::OnSize(UINT nType, int cx, int cy) 
{
	//CTrlEdDoc *pDoc = (CTrlEdDoc *)GetActiveDocument();
    if (!m_bInitialized)
        return;
    g_bResizing = TRUE;
    m_Splitter.SetColumnInfo(0, cx/2, 0);
    //m_Splitter.SetColumnInfo(1, cx-(cx/2), cx-(cx/2));
    m_Splitter.RecalcLayout();
    m_Splitter2.SetRowInfo(0, cy/2, 0);
    m_Splitter2.RecalcLayout();
    g_bResizing = FALSE;
    CMDIChildWnd::OnSize(nType, cx, cy);
}
