// ItemEditorPage1.cpp : implementation file
//

#include "stdafx.h"
#include "trled.h"
#include "trdefs.h"
#include "ItemEditorPage1.h"
#include "items.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CItemEditorPage1 property page

IMPLEMENT_DYNCREATE(CItemEditorPage1, CPropertyPage)

CItemEditorPage1::CItemEditorPage1() : CPropertyPage(CItemEditorPage1::IDD)
{
	//{{AFX_DATA_INIT(CItemEditorPage1)
	//}}AFX_DATA_INIT
    m_pItem = NULL;
}

CItemEditorPage1::~CItemEditorPage1()
{
}

void CItemEditorPage1::EnableAll(BOOL bEnable)
{
    m_Category.EnableWindow(bEnable);
    m_Item.EnableWindow(bEnable);
}

void CItemEditorPage1::DoDataExchange(CDataExchange* pDX)
{
    short nCategory;
    m_pItem = m_pDoc->m_pItem;
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CItemEditorPage1)
	DDX_Control(pDX, IDC_ITEM_NAME, m_Item);
	DDX_Control(pDX, IDC_ITEM_CATEGORY, m_Category);
	//}}AFX_DATA_MAP
    if (!pDX->m_bSaveAndValidate)
    {
        if (m_pItem)
        {
            nCategory = FindCategory(m_pItem->object);
            if (nCategory != -1)
            {
                m_Category.SetCurSel(nCategory);
                DoItemNames(nCategory, m_pItem->object);
            }
            EnableAll(TRUE);
        }
        else
        {
            m_Item.ResetContent();
            EnableAll(FALSE);
        }
    }
}


BEGIN_MESSAGE_MAP(CItemEditorPage1, CPropertyPage)
	//{{AFX_MSG_MAP(CItemEditorPage1)
	ON_CBN_SELCHANGE(IDC_ITEM_CATEGORY, OnSelchangeItemCategory)
	ON_CBN_SELCHANGE(IDC_ITEM_NAME, OnSelchangeItemName)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CItemEditorPage1 message handlers

short CItemEditorPage1::FindCategory(short object)
{
    int x;
    for (x = 0; x < NUM_ITEMS; x++)
    {
        if (itemdefs[x].object == object)
        {
            return itemdefs[x].category;
        }
    }
    return -1;
}

void CItemEditorPage1::DoItemNames(short nCategory, short object)
{
    int x, iItem, nSel;
    m_Item.ResetContent();
    nSel = 0;
    for (x = 0; x < NUM_ITEMS; x++)
    {
        if (itemdefs[x].category == nCategory)
        {
            iItem = m_Item.AddString(itemdefs[x].itemname);
            m_Item.SetItemData(iItem, itemdefs[x].object);
            if ((object != -1) && (itemdefs[x].object == object))
            {
                nSel = iItem;
            }
        }
    }
    m_Item.SetCurSel(nSel);
}

void CItemEditorPage1::OnSelchangeItemCategory() 
{
    int nSel;
    nSel = m_Category.GetCurSel();
    DoItemNames(nSel, -1);
    m_pItem->object = (short)m_Item.GetItemData(0);
}

void CItemEditorPage1::OnSelchangeItemName() 
{
    int iItem;
    iItem = m_Item.GetCurSel();
    m_pItem->object = (short)m_Item.GetItemData(iItem);
}

BOOL CItemEditorPage1::OnInitDialog() 
{
    int x;
	CPropertyPage::OnInitDialog();
    for (x = 0; x < NUM_ITEM_CATEGORIES; x++)
    {
        m_Category.AddString(item_categories[x]);
    }
	return TRUE;
}
