// SectorEditorPage1.cpp : implementation file
//

#include "stdafx.h"
#include "trled.h"
#include "TrlEdDoc.h"
#include "SectorEditorPage1.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSectorEditorPage1 property page

CSectorEditorPage1::CSectorEditorPage1() : CPropertyPage(CSectorEditorPage1::IDD)
{
    CWinApp *pApp = AfxGetApp();
    //{{AFX_DATA_INIT(CSectorEditorPage1)
    //}}AFX_DATA_INIT
    m_pSector = NULL;
    m_savedfloor = 0;
    m_savedceiling = -8;
    m_savedlrfloor = 0;
    m_savedudfloor = 0;
    m_savedlrceiling = 0;
    m_savedudceiling = 0;
    m_hUpArrow = LoadBitmap(pApp->m_hInstance, MAKEINTRESOURCE(IDB_UP_ARROW));
    m_hDownArrow = LoadBitmap(pApp->m_hInstance, MAKEINTRESOURCE(IDB_DOWN_ARROW));
    m_hLeftArrow = LoadBitmap(pApp->m_hInstance, MAKEINTRESOURCE(IDB_LEFT_ARROW));
    m_hRightArrow = LoadBitmap(pApp->m_hInstance, MAKEINTRESOURCE(IDB_RIGHT_ARROW));
    m_hFlat = LoadBitmap(pApp->m_hInstance, MAKEINTRESOURCE(IDB_FLAT));
}

CSectorEditorPage1::~CSectorEditorPage1()
{
    m_pSector = NULL;
    m_savedfloor = 4;
    m_savedceiling = -4;
    m_savedlrfloor = 0;
    m_savedudfloor = 0;
    m_savedlrceiling = 0;
    m_savedudceiling = 0;
    DeleteObject(m_hUpArrow);
    DeleteObject(m_hDownArrow);
    DeleteObject(m_hLeftArrow);
    DeleteObject(m_hRightArrow);
    DeleteObject(m_hFlat);
}

void CSectorEditorPage1::DoDataExchange(CDataExchange* pDX)
{
    TCHAR szTemp[512];
    CButton *pButton;
    CWnd *pWnd;
    m_pSector = &m_pDoc->m_trm.roomcurrent->room->sectors[m_pDoc->m_nSector];
    CPropertyPage::DoDataExchange(pDX);
    //{{AFX_DATA_MAP(CSectorEditorPage1)
    DDX_Control(pDX, IDC_HEIGHTSPIN, m_HeightSpin);
    //}}AFX_DATA_MAP
    if (!pDX->m_bSaveAndValidate)
    {
        m_fFloor = TRUE;
        pButton = (CButton *)GetDlgItem(IDC_FLOOR);
        pButton->SetCheck(1);
        pButton = (CButton *)GetDlgItem(IDC_CEILING);
        pButton->SetCheck(0);
        m_HeightSpin.SetPos(m_pSector->floor);
        itoa(m_pSector->lrfloor, szTemp, 10);
        pWnd = GetDlgItem(IDC_LR);
        pWnd->SetWindowText(szTemp);
        itoa(m_pSector->udfloor, szTemp, 10);
        pWnd = GetDlgItem(IDC_UD);
        pWnd->SetWindowText(szTemp);
        if ((m_pSector->floor == SECTOR_WALL) && (m_pSector->ceiling == SECTOR_WALL))
        {
            pWnd = GetDlgItem(IDC_FLOOR);
            pWnd->EnableWindow(FALSE);
            pWnd = GetDlgItem(IDC_CEILING);
            pWnd->EnableWindow(FALSE);
            pWnd = GetDlgItem(IDC_HEIGHTBUDDY);
            pWnd->EnableWindow(FALSE);
            pWnd = GetDlgItem(IDC_HEIGHTSPIN);
            pWnd->EnableWindow(FALSE);
            pWnd = GetDlgItem(IDC_LEFT);
            pWnd->EnableWindow(FALSE);
            pWnd = GetDlgItem(IDC_RIGHT);
            pWnd->EnableWindow(FALSE);
            pWnd = GetDlgItem(IDC_UP);
            pWnd->EnableWindow(FALSE);
            pWnd = GetDlgItem(IDC_DOWN);
            pWnd->EnableWindow(FALSE);
            pWnd = GetDlgItem(IDC_FLAT);
            pWnd->EnableWindow(FALSE);
            
            pButton = (CButton *)GetDlgItem(IDC_WALL);
            pButton->SetCheck(1);
            pButton = (CButton *)GetDlgItem(IDC_NORMAL);
            pButton->SetCheck(0);
        }
        else
        {
            pWnd = GetDlgItem(IDC_FLOOR);
            pWnd->EnableWindow(TRUE);
            pWnd = GetDlgItem(IDC_CEILING);
            pWnd->EnableWindow(TRUE);
            pWnd = GetDlgItem(IDC_HEIGHTBUDDY);
            pWnd->EnableWindow(TRUE);
            pWnd = GetDlgItem(IDC_HEIGHTSPIN);
            pWnd->EnableWindow(TRUE);
            pWnd = GetDlgItem(IDC_LEFT);
            pWnd->EnableWindow(TRUE);
            pWnd = GetDlgItem(IDC_RIGHT);
            pWnd->EnableWindow(TRUE);
            pWnd = GetDlgItem(IDC_UP);
            pWnd->EnableWindow(TRUE);
            pWnd = GetDlgItem(IDC_DOWN);
            pWnd->EnableWindow(TRUE);
            pWnd = GetDlgItem(IDC_FLAT);
            pWnd->EnableWindow(TRUE);
            
            pButton = (CButton *)GetDlgItem(IDC_NORMAL);
            pButton->SetCheck(1);
            pButton = (CButton *)GetDlgItem(IDC_WALL);
            pButton->SetCheck(0);

            m_savedfloor = m_pSector->floor;
            m_savedceiling = m_pSector->ceiling;
        }
    }
}


BEGIN_MESSAGE_MAP(CSectorEditorPage1, CPropertyPage)
    //{{AFX_MSG_MAP(CSectorEditorPage1)
    ON_BN_CLICKED(IDC_WALL, OnWall)
    ON_BN_CLICKED(IDC_NORMAL, OnNormal)
    ON_WM_VSCROLL()
    ON_BN_CLICKED(IDC_CEILING, OnCeiling)
    ON_BN_CLICKED(IDC_FLOOR, OnFloor)
    ON_BN_CLICKED(IDC_LEFT, OnLeft)
    ON_BN_CLICKED(IDC_RIGHT, OnRight)
    ON_BN_CLICKED(IDC_UP, OnUp)
    ON_BN_CLICKED(IDC_DOWN, OnDown)
    ON_BN_CLICKED(IDC_FLAT, OnFlat)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSectorEditorPage1 message handlers

void CSectorEditorPage1::UpdateViews(void)
{
    m_pDoc->UpdateAllViews(NULL, UPDATE_VIEW_SECTORS|UPDATE_VIEW_MAIN);
}

void CSectorEditorPage1::OnWall() 
{
    m_pSector->floor = SECTOR_WALL;
    m_pSector->ceiling = SECTOR_WALL;
    m_pSector->lrfloor = 0;
    m_pSector->udfloor = 0;
    m_pSector->lrceiling = 0;
    m_pSector->udceiling = 0;
    UpdateData(FALSE);
    UpdateViews();
}

void CSectorEditorPage1::OnNormal() 
{
    m_pSector->floor = m_savedfloor;
    m_pSector->ceiling = m_savedceiling;
    m_pSector->lrfloor = m_savedlrfloor;
    m_pSector->udfloor = m_savedudfloor;
    m_pSector->lrceiling = m_savedlrceiling;
    m_pSector->udceiling = m_savedudceiling;
    UpdateData(FALSE);
    UpdateViews();
}

void CSectorEditorPage1::OnFloor() 
{
    TCHAR szTemp[256];
    CButton *pButton;
    CWnd *pWnd;
    m_fFloor = TRUE;
    pButton = (CButton *)GetDlgItem(IDC_CEILING);
    pButton->SetCheck(0);
    m_HeightSpin.SetPos(m_pSector->floor);
    itoa(m_pSector->lrfloor, szTemp, 10);
    pWnd = GetDlgItem(IDC_LR);
    pWnd->SetWindowText(szTemp);
    itoa(m_pSector->udfloor, szTemp, 10);
    pWnd = GetDlgItem(IDC_UD);
    pWnd->SetWindowText(szTemp);
    UpdateViews();
}

void CSectorEditorPage1::OnCeiling() 
{
    TCHAR szTemp[256];
    CButton *pButton;
    CWnd *pWnd;
    m_fFloor = FALSE;
    pButton = (CButton *)GetDlgItem(IDC_FLOOR);
    pButton->SetCheck(0);
    m_HeightSpin.SetPos(m_pSector->ceiling);
    itoa(m_pSector->lrceiling, szTemp, 10);
    pWnd = GetDlgItem(IDC_LR);
    pWnd->SetWindowText(szTemp);
    itoa(m_pSector->udceiling, szTemp, 10);
    pWnd = GetDlgItem(IDC_UD);
    pWnd->SetWindowText(szTemp);
    UpdateViews();
}

void CSectorEditorPage1::OnLeft() 
{
    TCHAR szTemp[256];
    CWnd *pWnd;
    if (m_fFloor)
    {
        if (m_pSector->lrfloor < 127)
        {    
            m_savedlrfloor = m_pSector->lrfloor++;
        }
        itoa(m_pSector->lrfloor, szTemp, 10);
        pWnd = GetDlgItem(IDC_LR);
        pWnd->SetWindowText(szTemp);
    }
    else
    {
        if (m_pSector->lrceiling < 127)
        {    
            m_savedlrceiling = m_pSector->lrceiling++;
        }
        itoa(m_pSector->lrceiling, szTemp, 10);
        pWnd = GetDlgItem(IDC_LR);
        pWnd->SetWindowText(szTemp);
    }
    UpdateViews();
}

void CSectorEditorPage1::OnRight() 
{
    TCHAR szTemp[256];
    CWnd *pWnd;
    if (m_fFloor)
    {
        if (m_pSector->lrfloor > -128)
        {    
            m_savedlrfloor = m_pSector->lrfloor--;
        }
        itoa(m_pSector->lrfloor, szTemp, 10);
        pWnd = GetDlgItem(IDC_LR);
        pWnd->SetWindowText(szTemp);
    }
    else
    {
        if (m_pSector->lrceiling > -128)
        {    
            m_savedlrceiling = m_pSector->lrceiling--;
        }
        itoa(m_pSector->lrceiling, szTemp, 10);
        pWnd = GetDlgItem(IDC_LR);
        pWnd->SetWindowText(szTemp);
    }
    UpdateViews();
}

void CSectorEditorPage1::OnUp() 
{
    TCHAR szTemp[256];
    CWnd *pWnd;
    if (m_fFloor)
    {
        if (m_pSector->udfloor > -128)
        {    
            m_savedudfloor = m_pSector->udfloor--;
        }
        itoa(m_pSector->udfloor, szTemp, 10);
        pWnd = GetDlgItem(IDC_UD);
        pWnd->SetWindowText(szTemp);
    }
    else
    {
        if (m_pSector->udceiling > -128)
        {    
            m_savedudceiling = m_pSector->udceiling--;
        }
        itoa(m_pSector->udceiling, szTemp, 10);
        pWnd = GetDlgItem(IDC_UD);
        pWnd->SetWindowText(szTemp);
    }
    UpdateViews();
}

void CSectorEditorPage1::OnDown() 
{
    TCHAR szTemp[256];
    CWnd *pWnd;
    if (m_fFloor)
    {
        if (m_pSector->udfloor < 127)
        {    
            m_savedudfloor = m_pSector->udfloor++;
        }
        itoa(m_pSector->udfloor, szTemp, 10);
        pWnd = GetDlgItem(IDC_UD);
        pWnd->SetWindowText(szTemp);
    }
    else
    {
        if (m_pSector->udceiling < 127)
        {    
            m_savedudceiling = m_pSector->udceiling++;
        }
        itoa(m_pSector->udceiling, szTemp, 10);
        pWnd = GetDlgItem(IDC_UD);
        pWnd->SetWindowText(szTemp);
    }
    UpdateViews();
}

void CSectorEditorPage1::OnFlat() 
{
    TCHAR szTemp[256];
    CWnd *pWnd;
    if (m_fFloor)
    {
        m_savedlrfloor = m_pSector->lrfloor = 0;
        m_savedudfloor = m_pSector->udfloor = 0;
        itoa(m_pSector->lrfloor, szTemp, 10);
        pWnd = GetDlgItem(IDC_LR);
        pWnd->SetWindowText(szTemp);
        itoa(m_pSector->udfloor, szTemp, 10);
        pWnd = GetDlgItem(IDC_UD);
        pWnd->SetWindowText(szTemp);
    }
    else
    {
        m_savedlrceiling = m_pSector->lrceiling = 0;
        m_savedudceiling = m_pSector->udceiling = 0;
        itoa(m_pSector->lrceiling, szTemp, 10);
        pWnd = GetDlgItem(IDC_LR);
        pWnd->SetWindowText(szTemp);
        itoa(m_pSector->udceiling, szTemp, 10);
        pWnd = GetDlgItem(IDC_UD);
        pWnd->SetWindowText(szTemp);
    }
    UpdateViews();
}

BOOL CSectorEditorPage1::OnInitDialog() 
{
    CWnd *pWnd;
    CButton *pButton;
	CPropertyPage::OnInitDialog();
    pWnd = GetDlgItem(IDC_HEIGHTBUDDY);
    m_HeightSpin.SetBuddy(pWnd);
    m_HeightSpin.SetRange(127, -128);
    m_HeightSpin.SetPos(0);
    pButton = (CButton *)GetDlgItem(IDC_UP);
    pButton->SetBitmap(m_hUpArrow);
    pButton = (CButton *)GetDlgItem(IDC_DOWN);
    pButton->SetBitmap(m_hDownArrow);
    pButton = (CButton *)GetDlgItem(IDC_LEFT);
    pButton->SetBitmap(m_hLeftArrow);
    pButton = (CButton *)GetDlgItem(IDC_RIGHT);
    pButton->SetBitmap(m_hRightArrow);
    pButton = (CButton *)GetDlgItem(IDC_FLAT);
    pButton->SetBitmap(m_hFlat);
	return TRUE;
}

void CSectorEditorPage1::OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
    int id = pScrollBar->GetDlgCtrlID();
    if (id == IDC_HEIGHTSPIN)
    {
        if (m_fFloor)
        {
            m_savedfloor = m_pSector->floor = (s_char)nPos;
        }
        else
        {
            m_savedceiling = m_pSector->ceiling = (s_char)nPos;
        }
        UpdateViews();
    }
    CPropertyPage::OnVScroll(nSBCode, nPos, pScrollBar);
}
