// SectorView.cpp : implementation file
//

#include "stdafx.h"
#include "TrlEd.h"
#include "TrlEdDoc.h"
#include "TextileViewer.h"
#include "ObjtexViewer.h"
#include "SectorView.h"
#include "MainFrm.h"
#include "trmdefs.h"
#include "ChildFrm.h"
#include "Room.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSectorView

IMPLEMENT_DYNCREATE(CSectorView, CView)

CSectorView::CSectorView()
{
    m_xPos = 0;
    m_yPos = 0;
    m_nZoom = 6;
    m_pbmi = NULL;
}

CSectorView::~CSectorView()
{
}


BEGIN_MESSAGE_MAP(CSectorView, CView)
	//{{AFX_MSG_MAP(CSectorView)
	ON_WM_DESTROY()
	ON_WM_KEYDOWN()
	ON_WM_LBUTTONDOWN()
	ON_WM_SIZE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSectorView drawing

void CSectorView::OnDraw(CDC* pDC)
{
	//CDocument* pDoc = GetDocument();
    if ((!m_nBitmapWidth) || (!m_nBitmapHeight))
    {
        return;
    }
    if (pDC->BitBlt(0, 0, m_nBitmapWidth, m_nBitmapHeight, &m_BitmapDC, 0, 0, SRCCOPY) == 0)
    {    
        ASSERT(FALSE);
    }
}

/////////////////////////////////////////////////////////////////////////////
// CSectorView diagnostics

#ifdef _DEBUG
void CSectorView::AssertValid() const
{
	CView::AssertValid();
}

void CSectorView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CSectorView message handlers

void CSectorView::OnInitialUpdate() 
{
    RECT rect;
    CMainFrame *pMainFrame = (CMainFrame *)AfxGetMainWnd();
    CTrlEdDoc *pDoc = (CTrlEdDoc *)GetDocument();
    CDC *pDC;
    int x;
    m_nEditMode = pDoc->m_nEditMode;
    m_WallPen.CreatePen(PS_SOLID, 1, RGB(200, 0, 0));
    m_NormalPen.CreatePen(PS_SOLID, 1, RGB(127, 127, 127));
    m_SelectPen.CreatePen(PS_SOLID, 1, RGB(255, 255, 255));
    m_WhitePen.CreatePen(PS_SOLID, 1, RGB(255, 255, 255));
    m_YellowPen.CreatePen(PS_SOLID, 1, RGB(255, 255, 0));
    m_BluePen.CreatePen(PS_SOLID, 1, RGB(0, 0, 255));
    GetClientRect(&rect);
    m_nBitmapWidth = rect.right;
    m_nBitmapHeight = rect.bottom;
    if ((pDC = GetDC()) == NULL)
    {    
        ASSERT(FALSE);
    }
    if (m_BitmapDC.CreateCompatibleDC(pDC) == 0)
    {    
        ASSERT(FALSE);
    }
    //m_pbmi = (BITMAPINFO *)malloc(sizeof(BITMAPINFOHEADER)+(256*sizeof(RGBQUAD)));
    //memset(m_pbmi, 0, sizeof(BITMAPINFOHEADER)+(256*sizeof(RGBQUAD)));
    m_pbmi = (BITMAPINFO *)malloc(sizeof(BITMAPINFOHEADER)+(256*2));
    memset(m_pbmi, 0, sizeof(BITMAPINFOHEADER)+(256*2));
    m_pbmi->bmiHeader.biSize = sizeof(BITMAPINFOHEADER);
    m_pbmi->bmiHeader.biWidth = m_nBitmapWidth;
    m_pbmi->bmiHeader.biHeight = -m_nBitmapHeight;
    m_pbmi->bmiHeader.biPlanes = 1;
    m_pbmi->bmiHeader.biBitCount = 8;
    m_pbmi->bmiHeader.biCompression = BI_RGB;
    for (x = 1; x < 256; x++)
    {
        *(((WORD *)m_pbmi->bmiColors)+x) = (WORD)x;
    }
    if ((m_hBitmap = CreateDIBSection(m_BitmapDC.m_hDC, m_pbmi, DIB_PAL_COLORS, (void **)&m_pBitmapBits, NULL, 0)) == NULL)
    {
        DWORD err = GetLastError();
        ASSERT(FALSE);
    }
    if (m_Bitmap.Attach(m_hBitmap) == FALSE)
    {    
        ASSERT(FALSE);
    }
    if (m_BitmapDC.SelectObject(&m_Bitmap) == NULL)
    {    
        ASSERT(FALSE);
    }
    //memset(m_pBitmapBits, 0, m_nBitmapWidth*m_nBitmapHeight);
    ReleaseDC(pDC);
	//CView::OnInitialUpdate();
    pDoc->UpdateAllViews(NULL, UPDATE_VIEW_SECTORS);
}

void CSectorView::OnUpdate_SECTORS(void)
{
    CTrlEdDoc *pDoc = (CTrlEdDoc *)GetDocument();
    trm_room_t *room;
    int x, y, x1, y1, x2, y2, xCenter, yCenter, nZoom = 1 << m_nZoom, nSector;
    nSector = pDoc->m_nSector;
    room = pDoc->m_trm.roomcurrent->room;
    xCenter = (m_nBitmapWidth/2)-(((room->numxsectors*0x400)/nZoom)/2)+m_xPos;
    yCenter = (m_nBitmapHeight/2)-(((room->numysectors*-0x400)/nZoom)/2)+m_yPos;
    if (nSector != -1)
    {
        m_BitmapDC.SelectObject(&m_SelectPen);
        x = nSector/room->numysectors;
        y = nSector%room->numysectors;
        x1 = (((x*0x400))/nZoom)+xCenter;
        y1 = (((y*-0x400))/nZoom)+yCenter;
        x2 = ((((x+1)*0x400))/nZoom)+xCenter-1;
        y2 = ((((y+1)*-0x400))/nZoom)+yCenter+1;
        m_BitmapDC.MoveTo(x1, y1);
        m_BitmapDC.LineTo(x2, y1);
        m_BitmapDC.LineTo(x2, y2);
        m_BitmapDC.LineTo(x1, y2);
        m_BitmapDC.LineTo(x1, y1);
    }
}

void CSectorView::OnUpdate_ROOMS(void)
{
}

void CSectorView::OnUpdate_ITEMS(void)
{
    CTrlEdDoc *pDoc = (CTrlEdDoc *)GetDocument();
    trm_itemlist_t *i;
    trm_room_t *room;
    item2_t *selitem;
    int x, y, xCenter, yCenter, nZoom = 1 << m_nZoom;
    room = pDoc->m_trm.roomcurrent->room;
    selitem = pDoc->m_pItem;
    xCenter = (m_nBitmapWidth/2)-(((room->numxsectors*0x400)/nZoom)/2)+m_xPos;
    yCenter = (m_nBitmapHeight/2)-(((room->numysectors*-0x400)/nZoom)/2)+m_yPos;
    i = pDoc->m_trm.itemlisthead;
    while (i)
    {
        x = (i->item->x/nZoom)+xCenter;
        y = (-i->item->z/nZoom)+yCenter;
        m_BitmapDC.FillSolidRect(x-3, y-3, 6, 6, RGB(0, 0, 255));
        i = i->next;
    }
    if (selitem)
    {
        m_BitmapDC.SelectObject(&m_SelectPen);
        x = (selitem->x/nZoom)+xCenter;
        y = (-selitem->z/nZoom)+yCenter;
        DrawRectangle(x-4, y-4, x+4, y+4);
    }
}

void CSectorView::OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint) 
{
    TCHAR szTemp[256];
    CTrlEdDoc *pDoc = (CTrlEdDoc *)GetDocument();
    CMainFrame *pMainFrame = (CMainFrame *)AfxGetMainWnd();
    trm_room_t *room;
    trm_sector_t *sectors;
    int x, y, x1, y1, x2, y2, xCenter, yCenter, nZoom = 1 << m_nZoom;
    ASSERT_VALID(pDoc);
    if (!(lHint & UPDATE_VIEW_SECTORS))
    {
        return;
    }
    wsprintf(szTemp, "room: %d   zoom: %d  xpos: %d ypos: %d", pDoc->m_nRoom, m_nZoom, m_xPos, m_yPos);
    pMainFrame->m_wndStatusBar.SetPaneText(0, szTemp);
    pDoc->DoTitle();
    if ((!m_nBitmapWidth) || (!m_nBitmapHeight))
    {
        return;
    }
    if (m_nEditMode != pDoc->m_nEditMode)
    {
        m_nEditMode = pDoc->m_nEditMode;
    }
    room = pDoc->m_trm.roomcurrent->room;
    sectors = room->sectors;
    xCenter = (m_nBitmapWidth/2)-(((room->numxsectors*0x400)/nZoom)/2)+m_xPos;
    yCenter = (m_nBitmapHeight/2)-(((room->numysectors*-0x400)/nZoom)/2)+m_yPos;
    m_BitmapDC.BitBlt(0, 0, m_nBitmapWidth, m_nBitmapHeight, NULL, 0, 0, BLACKNESS);
    m_BitmapDC.SelectObject(&m_WallPen);
    for (x = 0; x < room->numxsectors; x++)
    {
        for (y = 0; y < room->numysectors; y++)
        {
            if ((sectors[(x*room->numysectors)+y].ceiling != SECTOR_WALL) || (sectors[(x*room->numysectors)+y].floor != SECTOR_WALL))
            {
                continue;
            }
            x1 = (((x*0x400))/nZoom)+xCenter;
            y1 = (((y*-0x400))/nZoom)+yCenter;
            x2 = ((((x+1)*0x400))/nZoom)+xCenter-1;
            y2 = ((((y+1)*-0x400))/nZoom)+yCenter+1;
            m_BitmapDC.MoveTo(x1, y1);
            m_BitmapDC.LineTo(x2, y1);
            m_BitmapDC.LineTo(x2, y2);
            m_BitmapDC.LineTo(x1, y2);
            m_BitmapDC.LineTo(x1, y1);
        }
    }
    
    m_BitmapDC.SelectObject(&m_NormalPen);
    for (x = 0; x < room->numxsectors; x++)
    {
        for (y = 0; y < room->numysectors; y++)
        {
            if ((sectors[(x*room->numysectors)+y].ceiling == SECTOR_WALL) && (sectors[(x*room->numysectors)+y].floor == SECTOR_WALL))
            {
                continue;
            }
            x1 = (((x*0x400))/nZoom)+xCenter;
            y1 = (((y*-0x400))/nZoom)+yCenter;
            x2 = ((((x+1)*0x400))/nZoom)+xCenter-1;
            y2 = ((((y+1)*-0x400))/nZoom)+yCenter+1;
            m_BitmapDC.MoveTo(x1, y1);
            m_BitmapDC.LineTo(x2, y1);
            m_BitmapDC.LineTo(x2, y2);
            m_BitmapDC.LineTo(x1, y2);
            m_BitmapDC.LineTo(x1, y1);
        }
    }
    switch (m_nEditMode)
    {
        case EDIT_MODE_SECTORS:
            OnUpdate_SECTORS();
            break;

        case EDIT_MODE_ROOMS:
            OnUpdate_ROOMS();
            break;

        case EDIT_MODE_ITEMS:
            OnUpdate_ITEMS();
            break;

        default:
            ASSERT(FALSE);
            break;
    }
    //if (m_nRoom == 0)
        //DrawRooms();
    /*else
    {
        m_nRoom = 1;
        DrawRooms_asm();
        DrawRooms_asm2();
    }*/
    //RedrawWindow(NULL, NULL, RDW_INVALIDATE|RDW_NOERASE|RDW_UPDATENOW);
    /*rect.left = 0;
    rect.top = 0;
    rect.right = m_nBitmapWidth;
    rect.bottom = m_nBitmapHeight;
    InvalidateRect(&rect, FALSE);*/
    Invalidate(FALSE);
}

void CSectorView::OnDestroy() 
{
    CTrlEdDoc *pDoc = (CTrlEdDoc *)GetDocument();
    CView::OnDestroy();
    free(m_pbmi);
    m_pbmi = NULL;
    m_WallPen.DeleteObject();
    m_NormalPen.DeleteObject();
    m_SelectPen.DeleteObject();
    m_Bitmap.DeleteObject();
    m_BitmapDC.DeleteDC();
}

void CSectorView::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags)
{
    CTrlEdDoc *pDoc = (CTrlEdDoc *)GetDocument();
    UINT nScanCode = nFlags & 0xff;
    BOOL bRedraw = FALSE;
    switch (nScanCode)
    {
        case 0x0d: //+=, keybd
            ZoomIn();
            bRedraw = TRUE;
            break;

        case 0x4e: //+, keypad
            ZoomIn();
            bRedraw = TRUE;
            break;

        case 0x0c: //-_, keybd
            ZoomOut();
            bRedraw = TRUE;
            break;

        case 0x4a: //-, keypad
            ZoomOut();
            bRedraw = TRUE;
            break;

        case 0x48: //up
            m_yPos += MOVE_STEP;
            bRedraw = TRUE;
            break;

        case 0x50: //down
            m_yPos -= MOVE_STEP;
            bRedraw = TRUE;
            break;

        case 0x4b: //left
            m_xPos += MOVE_STEP;
            bRedraw = TRUE;
            break;

        case 0x4d: //right
            m_xPos -= MOVE_STEP;
            bRedraw = TRUE;
            break;
        
        default:
            break;
    }
    if (bRedraw == TRUE)
    {
        pDoc->UpdateAllViews(NULL, UPDATE_VIEW_SECTORS);
    }
    if (!pDoc->m_bKeyDown)
    {
        CView::OnKeyDown(nChar, nRepCnt, nFlags);
    }
}

void CSectorView::OnLButtonDown_SECTORS(UINT nFlags, CPoint *point)
{
    CTrlEdDoc *pDoc = (CTrlEdDoc *)GetDocument();
    trm_room_t *room;
    int x, y, x1, y1, x2, y2, xCenter, yCenter, nZoom = 1 << m_nZoom;
    if (point->y <= m_nBitmapHeight)
    {
        room = pDoc->m_trm.roomcurrent->room;
        xCenter = (m_nBitmapWidth/2)-(((room->numxsectors*0x400)/nZoom)/2)+m_xPos;
        yCenter = (m_nBitmapHeight/2)-(((room->numysectors*-0x400)/nZoom)/2)+m_yPos;
        for (x = 0; x < room->numxsectors; x++)
        {
            for (y = 0; y < room->numysectors; y++)
            {
                x1 = (((x*0x400))/nZoom)+xCenter;
                y1 = (((y*-0x400))/nZoom)+yCenter;
                x2 = ((((x+1)*0x400))/nZoom)+xCenter;
                y2 = ((((y+1)*-0x400))/nZoom)+yCenter;
                if (((point->x >= x1) && (point->x < x2)) && ((point->y >= y2) && (point->y < y1)))
                {
                    pDoc->m_nSector = (x*room->numysectors)+y;
                    pDoc->UpdateAllViews(NULL, UPDATE_VIEW_EDITOR|UPDATE_VIEW_SECTORS);
                    break;
                }
            }
        }
    }
}

void CSectorView::DrawRectangle(int x1, int y1, int x2, int y2)
{
    m_BitmapDC.MoveTo(x1, y1);
    m_BitmapDC.LineTo(x1, y2);
    m_BitmapDC.LineTo(x2, y2);
    m_BitmapDC.LineTo(x2, y1);
    m_BitmapDC.LineTo(x1, y1);
}

void CSectorView::OnLButtonDown_ROOMS(UINT nFlags, CPoint *point)
{
}

void CSectorView::OnLButtonDown_ITEMS(UINT nFlags, CPoint *point)
{
    CTrlEdDoc *pDoc = (CTrlEdDoc *)GetDocument();
    trm_itemlist_t *i;
    trm_room_t *room;
    int x, y, xCenter, yCenter, nZoom = 1 << m_nZoom;
    room = pDoc->m_trm.roomcurrent->room;
    xCenter = (m_nBitmapWidth/2)-(((room->numxsectors*0x400)/nZoom)/2)+m_xPos;
    yCenter = (m_nBitmapHeight/2)-(((room->numysectors*-0x400)/nZoom)/2)+m_yPos;
    i = pDoc->m_trm.itemlisthead;
    while (i)
    {
        x = (i->item->x/nZoom)+xCenter;
        y = (-i->item->z/nZoom)+yCenter;
        if ((point->x >= x-3) && (point->x <= x+3) && (point->y >= y-3) && (point->y <= y+3))
        {
            pDoc->m_pItem = i->item;
            pDoc->UpdateAllViews(NULL, UPDATE_VIEW_EDITOR|UPDATE_VIEW_SECTORS);
            break;
        }
        i = i->next;
    }
}

void CSectorView::OnLButtonDown(UINT nFlags, CPoint point) 
{
    switch (m_nEditMode)
    {
        case EDIT_MODE_SECTORS:
            OnLButtonDown_SECTORS(nFlags, &point);
            break;

        case EDIT_MODE_ROOMS:
            OnLButtonDown_ROOMS(nFlags, &point);
            break;

        case EDIT_MODE_ITEMS:
            OnLButtonDown_ITEMS(nFlags, &point);
            break;

        default:
            ASSERT(FALSE);
            break;
    }
    CView::OnLButtonDown(nFlags, point);
}

void CSectorView::OnSize(UINT nType, int cx, int cy) 
{
    CTrlEdDoc *pDoc = (CTrlEdDoc *)GetDocument();
    if ((g_bResizing) || (!m_pbmi))
    {
        CView::OnSize(nType, cx, cy);
        return;
    }
    m_Bitmap.DeleteObject();
    m_nBitmapWidth = cx;
    m_nBitmapHeight = cy;
    if ((!m_nBitmapWidth) || (!m_nBitmapHeight))
    {
        return;
    }
    m_pbmi->bmiHeader.biWidth = m_nBitmapWidth;
    m_pbmi->bmiHeader.biHeight = -m_nBitmapHeight;
    if ((m_hBitmap = CreateDIBSection(m_BitmapDC.m_hDC, m_pbmi, DIB_PAL_COLORS, (void **)&m_pBitmapBits, NULL, 0)) == NULL)
    {
        DWORD err = GetLastError();
        ASSERT(FALSE);
    }
    if (m_Bitmap.Attach(m_hBitmap) == FALSE)
    {    
        ASSERT(FALSE);
    }
    if (m_BitmapDC.SelectObject(&m_Bitmap) == NULL)
    {    
        ASSERT(FALSE);
    }
    //memset(m_pBitmapBits, 0, m_nBitmapWidth*m_nBitmapHeight);
	//CView::OnInitialUpdate();
    CView::OnSize(nType, cx, cy);
    pDoc->UpdateAllViews(NULL, UPDATE_VIEW_SECTORS);
}

void CSectorView::ZoomIn(void)
{
    if (m_nZoom > 0)
    {    
        m_nZoom--;
    }
}

void CSectorView::ZoomOut(void)
{
    if (m_nZoom < 9)
    {    
        m_nZoom++;
    }
}
