// TrlEd.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include <io.h>
#include "TrlEd.h"
#include "MyMemory.h"
#include "TrlEdDoc.h"
#include "TextileViewer.h"
#include "ObjtexViewer.h"
#include "SectorView.h"
#include "ChildFrm.h"
#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

BOOL g_bResizing = TRUE;

/////////////////////////////////////////////////////////////////////////////
// CTrlEdApp

BEGIN_MESSAGE_MAP(CTrlEdApp, CWinApp)
    //{{AFX_MSG_MAP(CTrlEdApp)
    ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
	//}}AFX_MSG_MAP
    // Standard file based document commands
    ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
    ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTrlEdApp construction

CTrlEdApp::CTrlEdApp()
{
    m_pDoc = NULL;
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CTrlEdApp object

CTrlEdApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CTrlEdApp initialization

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
    CAboutDlg();

// Dialog Data
    //{{AFX_DATA(CAboutDlg)
    enum { IDD = IDD_ABOUTBOX };
    //}}AFX_DATA

    // ClassWizard generated virtual function overrides
    //{{AFX_VIRTUAL(CAboutDlg)
    protected:
    virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
    //}}AFX_VIRTUAL

// Implementation
protected:
    //{{AFX_MSG(CAboutDlg)
        // No message handlers
    //}}AFX_MSG
    DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
    //{{AFX_DATA_INIT(CAboutDlg)
    //}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
    CDialog::DoDataExchange(pDX);
    //{{AFX_DATA_MAP(CAboutDlg)
    //}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
    //{{AFX_MSG_MAP(CAboutDlg)
        // No message handlers
    //}}AFX_MSG_MAP
END_MESSAGE_MAP()

// App command to run the dialog
void CTrlEdApp::OnAppAbout()
{
    CAboutDlg aboutDlg;
    aboutDlg.DoModal();
}

/////////////////////////////////////////////////////////////////////////////
// CTrlEdApp commands

BOOL CTrlEdApp::InitInstance()
{
#ifdef _AFXDLL
    Enable3dControls();            // Call this when using MFC in a shared DLL
#else
    Enable3dControlsStatic();    // Call this when linking to MFC statically
#endif

    CMultiDocTemplate *pDocTemplate;
    pDocTemplate = new CMultiDocTemplate(
        IDR_TRLEDTYPE,
        RUNTIME_CLASS(CTrlEdDoc),
        RUNTIME_CLASS(CChildFrame), // custom MDI child frame
        RUNTIME_CLASS(CSectorView));
    AddDocTemplate(pDocTemplate);

    // create main MDI Frame window
    CMainFrame *pMainFrame = new CMainFrame;
    if (!pMainFrame->LoadFrame(IDR_MAINFRAME))
        return FALSE;
    m_pMainWnd = pMainFrame;

    pMainFrame->ShowWindow(SW_MAXIMIZE);
    pMainFrame->UpdateWindow();

    if (InitMyMemory(MAIN_MEMORY_SIZE, NUM_FREE_BLOCKS) == FALSE)
    {
        ASSERT(FALSE);
        return FALSE;
    }

    /*lstrcpy(szErr, "Unknown.");
    if (InitD3D(pMainFrame->m_hWnd) == FALSE)
    {
        wsprintf(szTemp, "Could not initialize DirectDraw/Direct3D.\nReason: %s", szErr);
        AfxMessageBox(szTemp, MB_APPLMODAL|MB_ICONSTOP);
        return FALSE;
    }*/
    //FinishD3D();
#ifdef _DEBUG
    //if (OpenDocumentFile("d:\\tomb\\data\\level2.phd") == NULL)
    //if (OpenDocumentFile("c:\\tomb2\\data\\wall.tr2") == NULL)
      //  ASSERT(FALSE);
    OnFileNew();
    //return FALSE;
#endif
    return TRUE;
}

int CTrlEdApp::ExitInstance() 
{
    FinishMyMemory();
	return CWinApp::ExitInstance();
}

BOOL CTrlEdApp::PreTranslateMessage(MSG* pMsg) 
{
    CTrlEdDoc *pDoc = (CTrlEdDoc *)m_pDoc;
    if (pDoc)
    {
        if (pMsg->message == WM_KEYDOWN)
        {
            pDoc->OnKeyDown(pMsg->hwnd, pMsg->wParam, pMsg->lParam);
            return TRUE;
        }
    }
	return CWinApp::PreTranslateMessage(pMsg);
}
