// TrlEdDoc.h : interface of the CTrlEdDoc class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_TRLEDDOC_H__6AD918AE_3A8C_11D1_8F2B_A88F8CDF667C__INCLUDED_)
#define AFX_TRLEDDOC_H__6AD918AE_3A8C_11D1_8F2B_A88F8CDF667C__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#define UPDATE_VIEW_MAIN    0x00000001
#define UPDATE_VIEW_SECTORS 0x00000002
#define UPDATE_VIEW_EDITOR  0x00000004

#define EDIT_MODE_SECTORS   0
#define EDIT_MODE_ROOMS     1
#define EDIT_MODE_ITEMS     2

#include "trdefs.h"
#include "trmdefs.h"

class CTrlEdDoc : public CDocument
{
protected: // create from serialization only
	CTrlEdDoc();
	DECLARE_DYNCREATE(CTrlEdDoc)

public:
    trm_t m_trm;
    CWnd *m_pChildFrame;
    CView *m_pMainView;
    CView *m_pSectorView;
    CView *m_pEditorView;
    item2_t *m_pItem;
    BOOL m_bKeyDown;
    int m_nSector;
    int m_nRoom;
    int m_nEditMode;

    void OnKeyDown(HWND hWnd, WPARAM wParam, LPARAM lParam);
    void DoTitle(void);

    void NextRoom(void);
    void PrevRoom(void);

	//{{AFX_VIRTUAL(CTrlEdDoc)
	public:
	virtual void Serialize(CArchive& ar);
	virtual BOOL OnOpenDocument(LPCTSTR lpszPathName);
	virtual void OnCloseDocument();
	virtual BOOL OnSaveDocument(LPCTSTR lpszPathName);
	virtual BOOL OnNewDocument();
	//}}AFX_VIRTUAL

public:
	virtual ~CTrlEdDoc();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:
	//{{AFX_MSG(CTrlEdDoc)
	afx_msg void OnViewTexturetiles();
	afx_msg void OnViewObjtextures();
	afx_msg void OnBuildTrl();
	afx_msg void OnNewRoom();
	afx_msg void OnSectorMode();
	afx_msg void OnRoomMode();
	afx_msg void OnItemMode();
	afx_msg void OnUpdateItemMode(CCmdUI* pCmdUI);
	afx_msg void OnUpdateSectorMode(CCmdUI* pCmdUI);
	afx_msg void OnUpdateRoomMode(CCmdUI* pCmdUI);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_TRLEDDOC_H__6AD918AE_3A8C_11D1_8F2B_A88F8CDF667C__INCLUDED_)
