//trmdefs.h

#ifndef _TRMDEFS_INCLUDED_
#define _TRMDEFS_INCLUDED_

#include "trdefs.h"
#include "trldefs.h"

#define TRM_VERSION 0
#define TRM_MAGIC ".trm"

#define MAX_FLOORDATA_SIZE 16

typedef struct
{
    //tr2 begin
    short fdindex; //slope of ceiling and floor? index to slopes?
    short camera;
    s_char floorattrib; //if 0xff floor is solid, if 0x0e, floor is not solid?, 0x01, 
    s_char floor;
    s_char ceilingattrib;
    s_char ceiling;
    //tr2 end
    s_char lrceiling; //left/right sector slope
    s_char udceiling; //up/down sector slope
    s_char lrfloor; //left/right sector slope
    s_char udfloor; //up/down sector slope
    short doorroom;
} trm_sector_t;

typedef struct
{
    unsigned char floordata[MAX_FLOORDATA_SIZE];
    short size;
    short index;
} trm_floordata_t;

typedef struct
{
    short index;
    roominfo_t roominfo;
    long nummeshwords;
    u_char *meshwords;
    roommesh2_t mesh;
    short numdoors;
    roomdoor_t *doors;
    short numxsectors;
    short numysectors;
    trm_sector_t *sectors;
    u_char un1;
    u_char lightlevel1;
    u_char un4;
    u_char lightlevel2;
    short numlights;
    roomlight2_t *lights;
    short un2; //always 0xffff?
    u_char water; //bit 0 set = water
    u_char un3;
} trm_room_t;

typedef struct
{
    char magic[4]; //TRM_MAGIC
    long trmversion; //version of .trm file
    long gameversion; //version of game
    char baselevel[12];
    char levelname[256];
    //char author[256]?;
} trm_header_t;

typedef struct trm_roomlist_s
{
    trm_room_t *room;
    struct trm_roomlist_s *next;
    struct trm_roomlist_s *prev;
} trm_roomlist_t;

typedef struct trm_itemlist_s
{
    item2_t *item;
    struct trm_itemlist_s *next;
    struct trm_itemlist_s *prev;
} trm_itemlist_t;

typedef struct
{
    trm_header_t header;
    long numtextiles;
    textile8_t *textiles8;
    textile16_t *textiles16;
    short numrooms;
    trm_roomlist_t *roomlisthead;
    trm_roomlist_t *roomlisttail;
    trm_roomlist_t *roomcurrent;
    long numfloordata;
    short *floordata;
    long numitems;
    trm_itemlist_t *itemlisthead;
    trm_itemlist_t *itemlisttail;
    //boxes, overlaps, etc.?
} trm_t;

#endif //_TRMDEFS_INCLUDED_
