// FileView.cpp : implementation file
//

#include "stdafx.h"
#include "TrlFe.h"
#include "FileView.h"
#include "TrlFeDoc.h"
#include "trldefs.h"
#include "trlfile.h"
#include "tr2.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CFileView

IMPLEMENT_DYNCREATE(CFileView, CListView)

CFileView::CFileView()
{
}

CFileView::~CFileView()
{
}


BEGIN_MESSAGE_MAP(CFileView, CListView)
	//{{AFX_MSG_MAP(CFileView)
	ON_NOTIFY_REFLECT(NM_DBLCLK, OnDblclk)
	ON_WM_KEYDOWN()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFileView diagnostics

#ifdef _DEBUG
void CFileView::AssertValid() const
{
	CListView::AssertValid();
}

void CFileView::Dump(CDumpContext& dc) const
{
	CListView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CFileView message handlers

void CFileView::OnInitialUpdate() 
{
    RECT rect;
    CListCtrl& lc = GetListCtrl();
    CDocument *pDoc = GetDocument();
    GetClientRect(&rect);
    lc.InsertColumn(0, "File name", LVCFMT_LEFT, rect.right/4, 0);
    lc.InsertColumn(1, "Level name", LVCFMT_LEFT, rect.right-(rect.right/4), 1);
    CListView::OnInitialUpdate();
}

BOOL CFileView::PreCreateWindow(CREATESTRUCT& cs) 
{
    cs.style = WS_CHILD|WS_VISIBLE|LVS_REPORT|LVS_SORTASCENDING|LVS_SINGLESEL;
	return CListView::PreCreateWindow(cs);
}

void CFileView::OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint) 
{
    TCHAR szPath[MAX_PATH], szFile[MAX_PATH], szTemp[256];
    WIN32_FIND_DATA fd;
    trl_header_t header;
    CListCtrl& lc = GetListCtrl();
    HANDLE hFile;
    CTrlFeDoc *pDoc = (CTrlFeDoc *)GetDocument();
    int x, ret;
    lc.DeleteAllItems();
    if (pDoc->m_szPath[0] == 0)
        return;
    wsprintf(szPath, "%s\\*.*", pDoc->m_szPath);
    hFile = FindFirstFile(szPath, &fd);
    if (hFile == INVALID_HANDLE_VALUE)
        return;
    x = 0;
    while (1)
    {
        if (!(fd.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY))
        {
            lstrcpy(szFile, fd.cFileName);
            strlwr(szFile);
            if (strstr(szFile, ".trl"))
            {
                //load the .trl file
                lc.InsertItem(x, szFile);
                wsprintf(szPath, "%s\\%s", pDoc->m_szPath, szFile);
                ret = LoadTrlHeader(szPath, &header);
                if (ret == TRL_OK)
                {
                    lc.SetItemText(x, 1, header.levelname);
                }
                else
                {
                    switch (ret)
                    {
                        case TRL_OLDER_VERSION:
                            wsprintf(szTemp, "(older version (%d), needs to be %d)", header.trlversion, TRL_VERSION);
                            lc.SetItemText(x, 1, szTemp);
                            break;
                        
                        case TRL_NEWER_VERSION:
                            wsprintf(szTemp, "(newer version (%d), download new TrlFe)", header.trlversion, TRL_VERSION);
                            lc.SetItemText(x, 1, szTemp);
                            break;

                        case TRL_WRONG_GAME_VERSION:
                            wsprintf(szTemp, "(wrong game version (%d))", header.gameversion, TRL_VERSION);
                            lc.SetItemText(x, 1, szTemp);
                            break;

                        default:
                            lc.SetItemText(x, 1, "(not a TrlEd level)");
                            break;
                    }
                }
                lc.SetItemData(x, ret);
                x++;
            }
        }
        if (FindNextFile(hFile, &fd) == FALSE)
            break;
    }
    FindClose(hFile);
}

void CFileView::PlaySelectedLevel(void)
{
    TCHAR szTemp[512], szFile[MAX_PATH], szTrlPath[MAX_PATH], szDestTr2[MAX_PATH], szBasePath[MAX_PATH], szBaseTr2[MAX_PATH], szPath[MAX_PATH];
    STARTUPINFO si;
    PROCESS_INFORMATION pi;
    tr2_t tr2;
    CListCtrl& lc = GetListCtrl();
    CTrlFeDoc *pDoc = (CTrlFeDoc *)GetDocument();
    CTrlFeApp *pApp = (CTrlFeApp *)AfxGetApp();
    int nTotal, x, nItemData;
    nTotal = lc.GetItemCount();
    for (x = 0; x < nTotal; x++)
    {
        if (lc.GetItemState(x, LVIS_SELECTED) & LVIS_SELECTED)
        {
            lc.GetItemText(x, 0, szFile, sizeof(szFile));
            wsprintf(szTrlPath, "%s\\%s", pDoc->m_szPath, szFile);
            nItemData = lc.GetItemData(x);
            if (nItemData == TRL_OK)
            {
                //create .tr2 level and launch tr2
                lstrcpy(szBasePath, pApp->m_szRetailDir);
                if (szBasePath[lstrlen(szBasePath)-1] != '\\')
                {
                    lstrcat(szBasePath, "\\");
                }
                lstrcat(szBasePath, "data");
                
                lstrcpy(szDestTr2, pApp->m_szDemoDir);
                if (szDestTr2[lstrlen(szDestTr2)-1] != '\\')
                {
                    lstrcat(szDestTr2, "\\");
                }
                lstrcat(szDestTr2, "data\\wall.tr2");

                lstrcpy(szBaseTr2, szBasePath);
                lstrcat(szBaseTr2, "\\wall.tr2");
                
                LoadTr2File(szBaseTr2, &tr2, 0);
                
                BuildTr2File(szDestTr2, szTrlPath, szBasePath, &tr2);
                memset(&si, 0, sizeof(STARTUPINFO));
                si.cb = sizeof(STARTUPINFO);
                memset(&pi, 0, sizeof(PROCESS_INFORMATION));
                lstrcpy(szPath, pApp->m_szDemoDir);
                if (szPath[lstrlen(szPath)-1] != '\\')
                {
                    lstrcat(szPath, "\\");
                }
                lstrcat(szPath, "tomb2.exe");
                CreateProcess(szPath, NULL, NULL, NULL, TRUE, 0, NULL, pApp->m_szDemoDir, &si, &pi);
            }
            else
            {
                switch (nItemData)
                {
                    case TRL_OLDER_VERSION:
                        wsprintf(szTemp, "'%s' is an older version, level needs to be updated (to version %d) by the author.", szFile, TRL_VERSION);
                        AfxMessageBox(szTemp, MB_ICONSTOP|MB_OK|MB_APPLMODAL);
                        break;
                    
                    case TRL_NEWER_VERSION:
                        wsprintf(szTemp, "'%s' is a newer version, download new TrlFe at www.primenet.com/~splat/trled.", szFile);
                        AfxMessageBox(szTemp, MB_ICONSTOP|MB_OK|MB_APPLMODAL);
                        break;

                    case TRL_WRONG_GAME_VERSION:
                        wsprintf(szTemp, "'%s' is for the wrong game version, get latest version of game.", szFile);
                        AfxMessageBox(szTemp, MB_ICONSTOP|MB_OK|MB_APPLMODAL);
                        break;
                    
                    default:
                        wsprintf(szTemp, "'%s' is not a TrlEd level.", szFile);
                        AfxMessageBox(szTemp, MB_ICONSTOP|MB_OK|MB_APPLMODAL);
                        break;
                }
            }
            break;
        }
    }
}

void CFileView::OnDblclk(NMHDR* pNMHDR, LRESULT* pResult) 
{
    PlaySelectedLevel();
	*pResult = 0;
}

void CFileView::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	BYTE scan = (BYTE)nFlags&0xff;
    if ((nChar == VK_RETURN) && (scan == 0x1c))
    {
        PlaySelectedLevel();
    }
    CListView::OnKeyDown(nChar, nRepCnt, nFlags);
}
