// PathDlg.cpp : implementation file
//

#include "stdafx.h"
#include <shlobj.h>
#include "trlfe.h"
#include "PathDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPathDlg dialog


CPathDlg::CPathDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CPathDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPathDlg)
	m_DemoDir = _T("");
	m_RetailDir = _T("");
	//}}AFX_DATA_INIT
}


void CPathDlg::DoDataExchange(CDataExchange* pDX)
{
    CTrlFeApp *pApp = (CTrlFeApp *)AfxGetApp();
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPathDlg)
	DDX_Text(pDX, IDC_DEMO_DIR, m_DemoDir);
	DDV_MaxChars(pDX, m_DemoDir, 260);
	DDX_Text(pDX, IDC_RETAIL_DIR, m_RetailDir);
	DDV_MaxChars(pDX, m_RetailDir, 260);
	//}}AFX_DATA_MAP
    if (pDX->m_bSaveAndValidate)
    {
        lstrcpy(pApp->m_szDemoDir, m_DemoDir);
        lstrcpy(pApp->m_szRetailDir, m_RetailDir);
        pApp->SaveRegInfo();
    }
}


BEGIN_MESSAGE_MAP(CPathDlg, CDialog)
	//{{AFX_MSG_MAP(CPathDlg)
	ON_BN_CLICKED(IDC_DEMO_BROWSE, OnDemoBrowse)
	ON_BN_CLICKED(IDC_RETAIL_BROWSE, OnRetailBrowse)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPathDlg message handlers

void CPathDlg::OnDemoBrowse() 
{
    TCHAR szDisplay[MAX_PATH];
    BROWSEINFO bi;
    LPITEMIDLIST lpIDList;
    bi.hwndOwner = m_hWnd;
    bi.pidlRoot = NULL;
    bi.pszDisplayName = szDisplay;
    bi.lpszTitle = "Tomb2 pcgamer demo directory";
    bi.ulFlags = BIF_RETURNONLYFSDIRS;
    bi.lpfn = NULL;
    bi.lParam = 0;
    lpIDList = SHBrowseForFolder(&bi);
    if (!lpIDList)
    {
        return;
    }
    SHGetPathFromIDList(lpIDList, m_DemoDir.GetBufferSetLength(MAX_PATH));
    UpdateData(FALSE);
}

void CPathDlg::OnRetailBrowse() 
{
    TCHAR szDisplay[MAX_PATH];
    BROWSEINFO bi;
    LPITEMIDLIST lpIDList;
    bi.hwndOwner = m_hWnd;
    bi.pidlRoot = NULL;
    bi.pszDisplayName = szDisplay;
    bi.lpszTitle = "Tomb2 retail directory";
    bi.ulFlags = BIF_RETURNONLYFSDIRS;
    bi.lpfn = NULL;
    bi.lParam = 0;
    lpIDList = SHBrowseForFolder(&bi);
    if (!lpIDList)
    {
        return;
    }
    SHGetPathFromIDList(lpIDList, m_RetailDir.GetBufferSetLength(MAX_PATH));
    UpdateData(FALSE);
}

BOOL CPathDlg::OnInitDialog() 
{
    CTrlFeApp *pApp = (CTrlFeApp *)AfxGetApp();
    m_DemoDir = pApp->m_szDemoDir;
    m_RetailDir = pApp->m_szRetailDir;
	CDialog::OnInitDialog();
	return TRUE;
}
