// TrlFe.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "TrlFe.h"
#include "MainFrm.h"
#include "TrlFeDoc.h"
#include "TrlFeView.h"
#include "PathDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CTrlFeApp

BEGIN_MESSAGE_MAP(CTrlFeApp, CWinApp)
	//{{AFX_MSG_MAP(CTrlFeApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
	ON_COMMAND(ID_PATHS, OnPaths)
	//}}AFX_MSG_MAP
	// Standard file based document commands
	ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTrlFeApp construction

CTrlFeApp::CTrlFeApp()
{
    memset(m_szDemoDir, 0, sizeof(m_szDemoDir));
    memset(m_szRetailDir, 0, sizeof(m_szRetailDir));
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CTrlFeApp object

CTrlFeApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CTrlFeApp initialization

BOOL CTrlFeApp::InitInstance()
{
    DWORD ret;

#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif

	// Change the registry key under which our settings are stored.
	SetRegistryKey(_T("Local AppWizard-Generated Applications"));

	LoadStdProfileSettings();  // Load standard INI file options (including MRU)

	// Register document templates

	CSingleDocTemplate* pDocTemplate;
	pDocTemplate = new CSingleDocTemplate(
		IDR_MAINFRAME,
		RUNTIME_CLASS(CTrlFeDoc),
		RUNTIME_CLASS(CMainFrame),       // main SDI frame window
		RUNTIME_CLASS(CTrlFeView));
	AddDocTemplate(pDocTemplate);

	// Parse command line for standard shell commands, DDE, file open
	CCommandLineInfo cmdInfo;
	ParseCommandLine(cmdInfo);

	// Dispatch commands specified on the command line
	if (!ProcessShellCommand(cmdInfo))
		return FALSE;
	m_pMainWnd->ShowWindow(SW_SHOW);
	m_pMainWnd->UpdateWindow();

    if (GetRegInfo() == FALSE)
    {
        CPathDlg dlg;
        ret = dlg.DoModal();
        if (ret != IDOK)
        {
            AfxMessageBox("TrlFe was not configured correctly.");
            return FALSE;
        }
    }

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
		// No message handlers
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// App command to run the dialog
void CTrlFeApp::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}

BOOL CTrlFeApp::GetRegInfo(void)
{
    HKEY hKey;
    DWORD ret, dw, dwType;
    ret = RegOpenKeyEx(HKEY_LOCAL_MACHINE, "SOFTWARE\\tombdev", 0, KEY_ALL_ACCESS, &hKey);
    if (ret != ERROR_SUCCESS)
    {
        return FALSE;
    }
    if (!hKey)
    {
        return FALSE;
    }
    dw = sizeof(m_szDemoDir);
    dwType = REG_SZ;
    ret = RegQueryValueEx(hKey, "DemoDir", NULL, &dwType, (LPBYTE)m_szDemoDir, &dw);
    if (ret != ERROR_SUCCESS)
    {
        return FALSE;
    }
    dw = sizeof(m_szRetailDir);
    dwType = REG_SZ;
    ret = RegQueryValueEx(hKey, "RetailDir", NULL, &dwType, (LPBYTE)m_szRetailDir, &dw);
    if (ret != ERROR_SUCCESS)
    {
        return FALSE;
    }
    RegCloseKey(hKey);
    return TRUE;
}

BOOL CTrlFeApp::SaveRegInfo(void)
{
    HKEY hKey;
    DWORD ret, dw;
    ret = RegCreateKeyEx(HKEY_LOCAL_MACHINE, "SOFTWARE\\tombdev", 0, "", REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL, &hKey, &dw);
    if (ret != ERROR_SUCCESS)
    {
        return FALSE;
    }
    if (!hKey)
    {
        return FALSE;
    }
    ret = RegSetValueEx(hKey, "DemoDir", 0, REG_SZ, (LPBYTE)m_szDemoDir, lstrlen(m_szDemoDir)+1);
    if (ret != ERROR_SUCCESS)
    {
        return FALSE;
    }
    ret = RegSetValueEx(hKey, "RetailDir", 0, REG_SZ, (LPBYTE)m_szRetailDir, lstrlen(m_szRetailDir)+1);
    if (ret != ERROR_SUCCESS)
    {
        return FALSE;
    }
    RegCloseKey(hKey);
    return TRUE;
}

void CTrlFeApp::OnPaths() 
{
    CPathDlg dlg;
    dlg.DoModal();
}
