//linklist.c

#ifdef __cplusplus
extern "C"
{
#endif

#include <string.h>
#include "MyMemory.h"
#include "linklist.h"

linklist_t *NewListItem(void *src, int size, linklist_t **head, linklist_t **tail)
{
    linklist_t *l;
    l = (linklist_t *)GetMemBlock(sizeof(linklist_t)+size);
    l->data = ((unsigned char *)l)+sizeof(linklist_t);
    if (src)
    {
        memcpy(l->data, src, size);
    }
    l->next = l->prev = NULL;
    if (!*head)
    {
        *head = *tail = l;
    }
    else
    {
        (*tail)->next = l;
        l->prev = *tail;
        *tail = l;
    }
    return l;
}

void FreeListItem(linklist_t *item, int datasize)
{
    FreeMemBlock(item->data, datasize);
    FreeMemBlock(item, sizeof(linklist_t));
}

#ifdef __cplusplus
}
#endif
