//trlfile.c

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdio.h>
#include <string.h>
#include <wtypes.h>
#include "types.h"
#include "trldefs.h"
#include "trdefs.h"

int LoadTrlHeader(char *lpszFileName, trl_header_t *header)
{
    FILE *f;
    long filesize;
    f = fopen(lpszFileName, "rb");
    if (!f)
    {    
        return TRL_ERROR;
    }
    fseek(f, 0, SEEK_END);
    filesize = ftell(f);
    fseek(f, 0, SEEK_SET);
    if (filesize < sizeof(trl_header_t))
    {
        fclose(f);
        return TRL_ERROR;
    }
    fread(header, sizeof(trl_header_t), 1, f);
    if (memcmp(header->magic, TRL_MAGIC, 4) != 0)
    {
        fclose(f);
        return TRL_ERROR;
    }
    if (header->trlversion < TRL_VERSION)
    {
        fclose(f);
        return TRL_OLDER_VERSION;
    }
    if (header->trlversion > TRL_VERSION)
    {
        fclose(f);
        return TRL_NEWER_VERSION;
    }
    if (header->gameversion != TR2_VERSION)
    {
        fclose(f);
        return TRL_WRONG_GAME_VERSION;
    }
    fclose(f);
    return 0;
}

#ifdef __cplusplus
}
#endif
